#ifndef IFBITMAPFONT_H_INCLUDED
#define IFBITMAPFONT_H_INCLUDED

#include <Unknwn.h>

// {BF4FED3E-4C3D-4e23-837A-BEF4DB927C76}
static const GUID IID_IFBitmapFont = 
{ 0xbf4fed3e, 0x4c3d, 0x4e23, { 0x83, 0x7a, 0xbe, 0xf4, 0xdb, 0x92, 0x7c, 0x76 } };

class __declspec(uuid("{BF4FED3E-4C3D-4e23-837A-BEF4DB927C76}")) IFBitmapFont: public IUnknown
{
public:

	typedef struct
	{
		char name[64];
		int  texture_idx; //in IFileTransfer array
		int  data_count;
	} FONT_DESCRIPTOR;

	typedef struct
	{
		int x, y;
		unsigned int width, height;
	} LETTER_FRAME;

	virtual HRESULT CALLBACK GetDesc( FONT_DESCRIPTOR &desc ) = 0;
	virtual HRESULT CALLBACK GetLetterData( LETTER_FRAME **data ) = 0;

};
#endif