#include "utils.h"

ULONG crc_table[256];

//---------------------------------------------------------------
/*
bool FileExists(const char* file_name)
{
	WIN32_FIND_DATAA find;
	if(FindFirstFileA(file_name,&find) == INVALID_HANDLE_VALUE) return false;
	return true;
}
*/
//---------------------------------------------------------------
void InitCrc32()
{
	ULONG crc;
	for (int i = 0; i < 256; i++)
	{
		crc = i;
		for (int j = 0; j < 8; j++)
			crc = crc & 1 ? (crc >> 1) ^ 0xEDB88320UL : crc >> 1;
 
		crc_table[i] = crc;
	};
}

ULONG Crc32(const char *buf)
{	
	ULONG crc = 0xFFFFFFFFUL;
	ULONG len = (ULONG)strlen(buf);
	while (len--) 
		crc = crc_table[(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	return crc ^ 0xFFFFFFFFUL;
}
//---------------------------------------------------------------