#pragma once

#include <DPE_Application_Include.h>

#include <math.h>
#include <string>
#include <StringUtils.h>
#include <vector>

using namespace std;

#include "Game.h"

struct NOISE_POINT
{
	int x;
	int y;
	int n_obj;
};

struct NOISE_LINE
{
	float x;
	float inercia;
	int life;
};

class Film {

private:
	vector<NOISE_LINE> _noise_lines;
	vector<NOISE_POINT> _noise_points;
	int move,move_line;

	void new_noise_line();

	void update_noise_points();

public:
	ITexture *tex_cadr, *tex_line, *tex_noise, *tex_shadow,
	*tex_noise1,
	*tex_noise2,
	*tex_noise3,
	*tex_noise4,
	*tex_noise5,
	*tex_noise6,
	*tex_noise7,
	*tex_noise8,
	*tex_noise9,
	*tex_noise10;

	Film(IResourceManager *g_pResMan);
	~Film();
	void process();
	void render();
};