﻿package elm.core {
	import elm.core.*;
	import flash.display.*;
	import flash.text.*;
	
	public dynamic class Text extends Sprite {
		private var _text:TextField;
		//private var _format:TextFormat;
		
		public function Text(x:Number, y:Number, w:Number, h:Number, obj:Object) {
			this.x = x+w*0.5;
			this.y = y+h*0.5;
		
			_text = new TextField();
			_text.x = -w*0.5;
			_text.y = -h*0.5;
			_text.width = w;
			_text.height = h;
			_text.selectable = false;
			_text.embedFonts = obj.embed;
			_text.multiline = true;
			_text.wordWrap = true;
			_text.antiAliasType = AntiAliasType.ADVANCED;
			_text.mouseEnabled = false;
			
			var format:TextFormat = new TextFormat(obj.font, obj.size, obj.color, obj.bold, obj.italic, obj.underline, obj.url, obj.target, obj.align, obj.leftMargin, obj.rightMargin, obj.indent, obj.leading);
			/*for(var key in _format) {
				trace(key);
				_format[key] = obj[key];
			}*/
			
			_text.defaultTextFormat = format;
			//_text.setTextFormat(_format);
			addChild(_text);
			//_text.mouseEnabled = false;
			//mouseEnabled = false;
			//mouseChildren = true;
			//enabled = false;
		}
		public function set text(s:String):void {
			_text.text = s;
			//if(format != null) _text.setTextFormat(format);
		}
		public function get text():String {
			return _text.text;
		}
		public function set a(v:Number):void {
			alpha = v;
			_text.alpha = v;
		}
	}
}
