﻿package game.room.entity {
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.*;
	import game.actor.Actor;
	import game.Entity;
	import physic.*;
	
	public class Platform extends Entity implements PhysicRecipient {
		protected var body:b2Body;
		protected var is_down_jumpable:Boolean = false;
		
		public function Platform(attrIn:Object) {
			super(attrIn);
		}
		
		public function isCollised(shape1:b2Shape):Boolean {
			if (is_down_jumpable && shape1.GetUserData() is Actor) {
				return (shape1.GetUserData() as Actor).is_fall_through_platforms;
			}
			return true;
		}
		
		public function getBodyDef():b2BodyDef {
			return null;
		}
		public function setBody(bodyIn:b2Body):void {
			body = bodyIn;
			// add shape <
		}
		public function getBody():b2Body {
			return body;
		}
	}
}