﻿package physic {
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Dynamics.b2ContactListener;
	import Box2D.Dynamics.Contacts.b2ContactResult;
	import game.Entity;

	public class Collision extends b2ContactListener {

		public override function Add(point:b2ContactPoint) : void {
			var owner1:* = point.shape1.GetUserData();
			var owner2:* = point.shape2.GetUserData();
			if (true) {
				if (owner1 is ContactRecipient) (owner1 as ContactRecipient).onContactUpdate(point.shape2, 1, point);
				if (owner2 is ContactRecipient) (owner2 as ContactRecipient).onContactUpdate(point.shape1, -1, point);
			}
		}
		
		public override function Persist(point:b2ContactPoint):void {
			var owner1:* = point.shape1.GetUserData();
			var owner2:* = point.shape2.GetUserData();
			if (true) {
				if (owner1 is ContactRecipient) (owner1 as ContactRecipient).onContactUpdate(point.shape2, 1, point);
				if (owner2 is ContactRecipient) (owner2 as ContactRecipient).onContactUpdate(point.shape1, -1, point);
			}
		}
		
		public override function Remove(point:b2ContactPoint):void {
			var owner1:* = point.shape1.GetUserData();
			var owner2:* = point.shape2.GetUserData();
			if (true) {
				if (owner1 is ContactRecipient) (owner1 as ContactRecipient).onContactRemove(point.shape2, 1, point);
				if (owner2 is ContactRecipient) (owner2 as ContactRecipient).onContactRemove(point.shape1, -1, point);
			}
		}
		
		public override function Result(result:b2ContactResult):void {
			var owner1:* = result.shape1.GetUserData();
			var owner2:* = result.shape2.GetUserData();
			if (true) {
				if (owner1 is ContactRecipient) (owner1 as ContactRecipient).onContactResult(result.shape2, 1, result);
				if (owner2 is ContactRecipient) (owner2 as ContactRecipient).onContactResult(result.shape1, -1, result);
			}
		}
	}
}