unit e_render;

interface

uses Windows, OpenGL, e_global, e_screen, e_utils, e_font, e_game, e_camera,
     e_models, e_textures, e_particles, e_types, e_about, e_gui;

procedure Render;

implementation

uses e_main;

procedure glCopyTexImage2D(target : GLenum; level : GLint; internalFormat : GLenum; x, y : GLint; width, height: GLsizei; border : GLint); stdcall; external opengl32;

procedure Render;
begin
ViewPerspective(camera);
MoveCamera(camera);
//ViewOrtho;

glDisable(GL_LIGHTING);
glEnable(GL_TEXTURE_2D);
glDisable(GL_DEPTH_TEST);

glEnable(GL_BLEND);
glEnable(GL_TEXTURE_2D);
font.gui_mode := false;

if game_started then
  begin
    glEnable(GL_DEPTH_TEST);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    game.Render;
  end;

////////////

if not menu_active then
  begin
    glDisable(GL_DEPTH_TEST);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0, 1, screen.aspect, 0, -1, 1);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    gui.Render;
  end;
end;

end.
