// Keyboard.cpp: implementation of the CKeyboard class.
//
//////////////////////////////////////////////////////////////////////

#include "Keyboard.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CKeyboard::CKeyboard()
{
	memset(Key, 0x00, sizeof(Key));
}

CKeyboard::~CKeyboard()
{

}

// Keyboard Press wth Pause //
bool CKeyboard::Press(int pkey)
{
	bool complete = FALSE;

	if (Key[pkey]) {
		if (!StopKey[pkey]) {
			complete = TRUE;
			StopKey[pkey] = TRUE;
		}
	} else StopKey[pkey] = FALSE;

	if (complete) return TRUE;
	return FALSE;
}