
#include "Weapons.h"

WeaponInfo WeaponsInfo[3] =
{
	{ WEAPON_RIFLE, "penguins", 0, NULL, 0, NULL, 32.0f,  6.0f, 0.6f,  0.45f,  0, 375.0f, 200.0f,  8.0f, 2.0f,  8.0f, 1.5f, 0.0f, 0 },
	{ WEAPON_MINI,  "fishes",   0, NULL, 0, NULL, 25.0f,  2.0f, 0.2f,  0.15f,  1, 450.0f, 300.0f,  5.0f, 1.6f,  2.0f, 1.5f, 0.4f, 1 },
	{ WEAPON_BALL,  "jumpers",  0, NULL, 0, NULL, 25.0f, 10.0f, 1.1f,  0.75f, -1, 300.0f, 400.0f, 10.0f, 1.05f, 1.0f, 0.5f, 1.0f, -1 }
};

void InitializeWeapons()
{
	WeaponSector *s;
	WeaponInfo *w;

	// WEAPON_RIFLE
	w = &WeaponsInfo[0];
	s = new WeaponSector(0.0f, M_PI);
	w -> WeaponSectors.Add(s);

	// WEAPON_MINI
	w = &WeaponsInfo[1];
	s = new WeaponSector(0.0f, M_PI_4);
	w -> WeaponSectors.Add(s);

	s = new WeaponSector(3.0f * M_PI_4, M_PI);
	w -> WeaponSectors.Add(s);

	// WEAPON_BALL
	w = &WeaponsInfo[2];
	s = new WeaponSector(0.0f, M_PI / 2.15f);
	w -> WeaponSectors.Add(s);

	s = new WeaponSector(M_PI / 1.85f, M_PI);
	w -> WeaponSectors.Add(s);
}