unit Live;

//   

interface
uses
  S_map, S_game, S_ai, LexUtils;

const
  gravity = 8;
  
var                      
  kX, kY : word;

procedure Move(pX, pY : shortint; T : TTPers; var P : Tpers; var P2 : TPersP2);
function KlNoClip(kkX, kkY : byte; Y : integer) : boolean;

implementation

function KlNoClip(kkX, kkY : byte; Y : integer) : boolean; // ,   
begin
  if  ( Map.Kl[kkX, kkY].T in [clip, clip2])  // 
  or  ((Map.Kl[kkX, kkY].T=top ) and (Y > (kkY)*S_Map.Ed_Y+64  ))
  or  ((Map.Kl[kkX, kkY].T=left) and (Y > (kkY)*S_Map.Ed_Y+20  ))
  then
  result:=false
  else
  result:=true;
end;

procedure Move(pX, pY : shortint; T : TTPers; var P : Tpers; var P2 : TPersP2);
var
  nkX, kX2, nkY, kY_2 : word; //  x y,   x y
  vc : shortint;              //  + - 1
  realpY : shortint;
//_______________________________________________________
  function pW (XY : shortint) : byte; //  
  begin
    case XY of
      -1 : result:= round(T.W*0.1);
       0 : result:= T.W div 2;
       1 : result:= T.W;
    end;
  end;
//______________________________________________________
begin
  if P2.Live>10 then
    begin
      if (P.Y>16*S_map.Ed_Y)
      or (P.X<=-64)
       then P2.Live:=10
      else
      if P2.Live<=11 then
        begin
	        if P2.Animation<>12 then
		        begin
			        P2.AnimationPr:=12;
			        P2.AnimationN:=1;
			        P2.PrV:=0.15;
		  	      P2.Pr:=true;
	  	      end
  		    else
            if P2.AnimationN>=T.MofT[12]-1	then
		        P2.Live:=10;
            P2.Animation:=12;
        end
      else
      begin
        kX := ( P.X+round(T.W*0.45))  div S_map.Ed_X;
        kX2:= ( P.X+round(T.W*0.75))  div S_map.Ed_X;

        kY := ( P.Y+T.H  )  div S_map.Ed_Y;
        kY_2:=( P.Y+10   )  div S_map.Ed_Y;

        realpY:=pY;
        pY:=round(gravity - P2.Antigravity);      //   
  
        if P2.Antigravity>0 then
        app(P2.Antigravity, -0.5)
        else
        P2.Antigravity:=0;
  
        if pY>0 then
          nkY:= round( P.Y + T.H + pY) div S_map.Ed_Y
        else
          nkY:= round( P.Y + pY) div S_map.Ed_Y;

        if  (KlNoClip(kX,  nkY, P.Y +  pY + T.H))
        and (KlNoClip(kX2, nkY, P.Y +  pY + T.H)) then
          begin
            inc(P.Y, round(pY));                   //  "" (() Pixar)  
            if (P2.Animation<>4) and (P2.Animation<>5) then
            if gravity > P2.Antigravity then
              begin
                if (P2.F) or (P2.Animation=8) then // 
                P2.Animation:=5
                else
                P2.Animation:=4;
              end
            else
              begin
                if (P2.F) or (P2.Animation=1) then // 
                P2.Animation:=8
                else
                P2.Animation:=9;
              end;
          end
        else
        if gravity > P2.Antigravity then
          begin
            if  (Map.Kl[kX,  nkY].T in [clip, clip2])
            or  (Map.Kl[kX2, nkY].T in [clip, clip2])
            then
            P.Y:=(kY+1)*Ed_Y-T.H-8;
            if realpY>0 then
              begin
                if P2.Animation<>10 then P2.AnimationN:=1;
                P2.Animation:=10;
                if P2.AnimationN<T.MofT[10] then
                app(P2.AnimationN, 0.5);
              end
            else
            case P2.Animation of
              4 : begin
                    P2.AnimationN:=1;
                    P2.AnimationPr:=2;
                    P2.Animation:=6;
                    P2.PrV:=0.15;
                    P2.Pr:=true;
                  end;
              5: begin
                    P2.AnimationN:=1;
                    P2.AnimationPr:=1;
                    P2.Animation:=7;
                    P2.PrV:=0.15;
                    P2.Pr:=true;
                  end ;
             10 : begin
                    P2.AnimationN:=T.MofT[10]-P2.AnimationN+1;
                    P2.AnimationPr:=1;
                    P2.Animation:=6;
                    P2.PrV:=0.2;
                    P2.Pr:=true;
                  end ;
          end;
      end;
  
    //   - 
    if (pX<>0) and (not P2.Pr) and (P2.Animation<>10) then
      begin
        if P2.Shift then
        T.Spd:=T.Spd*2.5; // 

        nkX:= round( P.X+pW(pX) + pX*T.Spd ) div S_map.Ed_X;

        if  (KlNoClip(nkX, kY  , P.Y+T.H))
        and (KlNoClip(nkX, kY_2, P.Y+T.H)) then
          begin
                if (P2.Animation <4) then
                begin
                  if P2.Shift then
                    begin
                      P2.Animation:=3;
                      app(P2.AnimationN, 0.25);
                    end
                  else
                    begin
                      P2.Animation:=2;
                      app(P2.AnimationN, 0.25);
                    end;
                  P2.F:=false;    //    
                  P2.TrueInF:=160 //    ...
                end;
            inc(P.X, round(pX*T.Spd));
            end;
           end;

        case pX of                 //   
          -1 : P2.left := true;
           1 : P2.left := false;
        end;
  end;

  if (pX=0) and (P2.Animation in [2,3]) then
  if P2.TrueInF>0 then dec(P2.TrueInF)
                  else begin
                         P2.Animation:=1;
                         P2.F:=true;
                       end;

   //  
    if P2.Animation=1 then
    app(P2.AnimationN, 0.05);
  
    if P2.Pr then
      begin
        app(P2.AnimationN, P2.PrV);
  
        if ((P2.PrV<0) and (P2.AnimationN<=1))
        or ((P2.PrV>0) and (P2.AnimationN>=T.MofT[P2.Animation])) then
          begin
            P2.Animation:=P2.AnimationPr;
            P2.Pr:=false;
          end;
      end
    else   //  
      begin
        if P2.AnimationN>T.MofT[P2.Animation] then P2.AnimationN:=1
        else
        if P2.AnimationN<1 then P2.AnimationN:=T.MofT[P2.Animation];
      end;
     if (not P2.Shift) and (P2.Animation=3) then
     P2.Animation:=2;
  end;
end;
 
end.
