program painted_door;
//
uses
  Windows,
  LexUtils,
  OMEGA,
  S_mainproc in 'S_mainproc.pas',
  S_map in 'S_map.pas',
  S_materials in 'S_materials.pas',
  S_game in 'S_game.pas',
  Live in 'Live.pas',
  S_ai in 'S_ai.pas',
  Setup in 'Setup.pas',
  S_Scripts in 'S_Scripts.pas',
  MScenes in 'MScenes.pas',
  S_Dura in 'S_Dura.pas',
  S_IniPers in 'S_IniPers.pas',
  S_Hero in 'S_Hero.pas';

//  

var
  MTimer : POTimer;


begin
  // ____  
  LoadOMEGA('DX\OMEGA.dll');

  OE_RegProcedure(SYS_INIT, @S_mainproc.Init);
  OE_RegProcedure(SYS_QUIT, @S_mainproc.Quit);
  OE_RegProcedure(SYS_DRAW, @S_mainproc.Draw);

  MTimer := Timer_Create(   @S_mainproc.Work, 12);

  OE_SetScreenOptions(1024, 768, 32, 0, false, false);
  Omega.OE_SetWndPosition((GetSystemMetrics(SM_CXSCREEN) - 1024) div 2 ,
                           -5{(GetSystemMetrics(SM_CYSCREEN) - 768) div 2 -20} );

  TofGame:=Tgame; //   

  OE_Init;
end.
