unit S_Hero;

interface
uses
  Omega;

var
  gpX : array[6..12, 0..9] of byte;
  gpY : array[6..12, 0..9] of byte;

procedure addPoints;
procedure Draw;

implementation
uses
  S_materials, S_Game, S_Map;

procedure addPoints;  //     _6, _7  _8
begin
  gpX[6, 1]:= 33;
  gpY[6, 1]:= 98;
  gpX[6 ,2]:= 20;
  gpY[6 ,2]:= 84;
  gpX[6 ,3]:= 20;
  gpY[6 ,3]:= 76;
  gpX[6 ,4]:= 20;
  gpY[6 ,4]:= 69;

  gpX[7 ,1]:= 22;
  gpY[7 ,1]:=104;
  gpX[7 ,2]:= 25;
  gpY[7 ,2]:= 98;
  gpX[7 ,3]:= 26;
  gpY[7 ,3]:= 86;
  gpX[7 ,4]:= 26;
  gpY[7 ,4]:= 80;

  gpX[10,1]:= 19;
  gpY[10,1]:= 69;
  gpX[10,2]:= 19;
  gpY[10,2]:= 76;
  gpX[10,3]:= 19;
  gpY[10,3]:= 86;
  gpX[10,4]:= 28;
  gpY[10,4]:= 96;
  gpX[10,5]:= 22;
  gpY[10,5]:=102;
  gpX[10,6]:= 22;
  gpY[10,6]:=102;

  gpX[12,1]:= 34;
  gpY[12,1]:= 55;
  gpX[12,2]:= 37;
  gpY[12,2]:= 27;
  gpX[12,3]:= 40;
  gpY[12,3]:= 55;
  gpX[12,4]:= 43;
  gpY[12,4]:= 65;
  gpX[12,5]:= 47;
  gpY[12,5]:= 77;
  gpX[12,6]:= 52;
  gpY[12,6]:= 85;
  gpX[12,7]:= 57;
  gpY[12,7]:=100;
  gpX[12,8]:= 65;
  gpY[12,8]:=120;
end;

procedure Draw;
var
  Flag : integer;
begin

  if HeroP2.Left then Flag:=FX_DEFAULT or FX_FLIPX
  else Flag:=1;

  if Map.Hero.T>0 then
  Omega.ASprite_Draw(THero[HeroP2.Animation],
                     Map.Hero.X-CameraX, Map.Hero.Y-CameraY,
                     HeroT.W, HeroT.H,
                     round(HeroP2.AnimationN), 255, 0, Flag);

  if (not (HeroP2.Animation in [6,7,10,12])) then
    begin
      if HeroP2.Left then
      Omega.SSprite_Draw(TGun[UsedGun],
                         Map.Hero.X - CameraX + 1,
                         Map.Hero.Y - CameraY + HeroT.Gun_pY,
                         32, 32, 255, 0, Flag)
      else
      Omega.SSprite_Draw(TGun[UsedGun],
                         Map.Hero.X - CameraX + 95,
                         Map.Hero.Y - CameraY + HeroT.Gun_pY,
                         32, 32);
    end
  else
    begin
      if HeroP2.Left then
      Omega.SSprite_Draw(TGun[UsedGun],
                         Map.Hero.X - CameraX + 32 - gpX[HeroP2.Animation, round(HeroP2.AnimationN)],
                         Map.Hero.Y - CameraY      + gpY[HeroP2.Animation, round(HeroP2.AnimationN)],
                         32, 32, 255, 0, Flag)
      else
      Omega.SSprite_Draw(TGun[UsedGun],
                         Map.Hero.X - CameraX + 64 + gpX[HeroP2.Animation, round(HeroP2.AnimationN)],
                         Map.Hero.Y - CameraY      + gpY[HeroP2.Animation, round(HeroP2.AnimationN)],
                         32, 32);
    end;

end;

end.
