unit S_ai;    //  ,     ,   

interface

uses
  Omega, S_materials;

type
  TTpers = record                 // 
    CRun,  CFly,                  //  , 
    CFire, CJ   : boolean;        //  , 
    Spd  : single;                // 
    MofT : array[1..15] of byte;  //  
    Gun_pY, T_Gun : byte;         //     
                                  //  
    H, W : integer;               // , 
  end;

  TpersP2 = record
    Animation, AnimationPr,             // ,   ,
    Live        : byte;                 // 
    AnimationN, PrV, FireN  : single;   //  , + -,  
    Pr, Left, Shift, F, HG  : boolean;  //   ,
                                        // , , , 
    Antigravity : single;               //  
    TrueInF     : byte;                 //   F=TRUE
  end;

var
  BotP2  : array of TpersP2;          // 
  BotT   : array[1..10] of TTPers;    //  

procedure Draw;
procedure Work;

implementation

uses
   S_map, S_game, S_Dura, LexUtils, Live;

function firepW(XY, T : shortint) : integer;
  begin
    case XY of
      -1 : result:= 0;
       1 : result:= BotT[1].W;
    end;
  end;

procedure Work;
var
  I, pY, pX : integer;

//   
  function ISeeHero : boolean;
  begin
    if  (   ((BotP2[I].Left)     and (Map.Hero.X>Map.Bot[I].X-700) and (Map.Hero.X<Map.Bot[I].X+450))
         or ((not BotP2[I].Left) and (Map.Hero.X>Map.Bot[I].X-350) and (Map.Hero.X<Map.Bot[I].X+600)))
    and (Map.Hero.Y>Map.Bot[I].Y-300) and (Map.Hero.Y<Map.Bot[I].Y+700)
    then
      result:=true
    else
      result:=false;
  end;
//______________________________________________

//___________ BOT1 _____________________________
  procedure bot1work;
  var
    MoveX : shortint;
  begin
  // 
     if (Map.Bot[I].X<S_Map.Ed_X)
     or (Map.Bot[I].X>S_Map.Ed_X*(Map.MofKlX-1))
     or (Map.Bot[I].X>16*S_map.Ed_Y)
      then
       BotP2[I].Live:=0
     else

     if (BotP2[I].Live>11) and (ISeeHero) then
       begin
         if Map.Hero.X<Map.Bot[I].X then BotP2[I].Left:=true
                                    else BotP2[I].Left:=false;

         if  BotP2[I].Left then MoveX:=-1
                           else MoveX:= 1;

         if  (BotP2[I].Live>11)
         and ((HeroP2.Animation<4))
         and (abs(Map.Hero.X-Map.Bot[I].X)<70)
         and (abs(Map.Hero.X-Map.Bot[I].X)>30)
         then
           begin
             MoveX:=0;
             if BotP2[I].Animation<>13 then
                   begin
                     BotP2[I].Animation:=13;
                     BotP2[I].AnimationPr:=1;
                     BotP2[I].AnimationN:=1;
                     BotP2[I].Pr:=true;
                     BotP2[I].PrV:=0.5;
                   end
                 else
                 if  (BotP2[I].Animation=13)
                 and (BotP2[I].AnimationN>=7)
                 then
                   begin
                     HeroP2.Animation:=11;
                     HeroP2.AnimationN:=1;
                     HeroP2.Pr:=true;
                     HeroP2.PrV:=0.1;
                     if HeroP2.Live-30<=11 then
                     HeroP2.Live:=11
                     else
                     dec(HeroP2.Live, 30);
                   end;
           end;
       end
       else
       MoveX:=0;

     Live.Move(MoveX, 0, BotT[Map.Bot[I].T], Map.Bot[I], BotP2[I]);
  end;
//______________________________________________

//___________ BOT2 _____________________________
  procedure bot2work;
  begin
  pY:=0;
      if (BotP2[I].Live>11) and (ISeeHero) then  //   
        begin
          if Map.Hero.X<Map.Bot[I].X then BotP2[I].Left:=true else BotP2[I].Left:=false;

          if Map.Bot[I].Y + BotT[Map.Bot[I].T].H = HerokY*S_map.Ed_Y + HeroT.Gun_pY +1  then
            begin
              if (BotP2[I].Animation<4)
              or (BotP2[I].AnimationN>=BotT[1].MofT[BotP2[I].Animation]) then
                 begin
                   BotP2[I].Animation:=5;
                   BotP2[I].AnimationN:=1;
                 end;
            end
          else
          if Map.Bot[I].Y + BotT[Map.Bot[I].T].H < HerokY*S_map.Ed_Y + HeroT.Gun_pY +1  then
            pY:=1 else pY:=-1;   //    "" (() Pixar)
        end;
      // ________________________________
      if BotP2[I].Animation=6 then pY:=2;
      Map.Bot[I].Y:=round(Map.Bot[I].Y+pY*BotT[1].Spd);

      if (BotP2[I].Live<=11) and

      (not Live.KlNoClip((Map.Bot[I].X+BotT[Map.Bot[I].T].W div 2) div S_map.Ed_X,
                         (Map.Bot[I].Y+BotT[Map.Bot[I].T].H + 2  ) div S_map.Ed_Y,
                          Map.Bot[I].Y))  
      then
      BotP2[I].Live:=1;

      if  (BotP2[I].Animation=5) and (BotP2[I].AnimationN>4) and (BotP2[I].AnimationN<4.2)
      then
        begin
          if BotP2[I].Left then pX:=-1 else pX:=1;
          S_Dura.Fire(Map.Bot[I].X+firepW(pX, Map.Bot[I].T), Map.Bot[I].Y+BotT[1].Gun_pY, BotT[Map.Bot[I].T].T_Gun, pX);
        end;

      if BotP2[I].Animation<4 then
        case pY of
          -1 : BotP2[I].Animation:=3;
           0 : BotP2[I].Animation:=1;
           1 : BotP2[I].Animation:=2;
        end

      else
      if BotP2[I].Animation<>6 then
      if  (BotP2[I].AnimationN>=BotT[1].MofT[BotP2[I].Animation]-1) then
        begin
          BotP2[I].Animation:=1;
          BotP2[I].AnimationN:=1;
        end;

      app(BotP2[I].AnimationN, 0.15);
      if BotP2[I].AnimationN>BotT[1].MofT[BotP2[I].Animation] then BotP2[I].AnimationN:=1
      else
      if BotP2[I].AnimationN<1 then BotP2[I].AnimationN:=BotT[1].MofT[BotP2[I].Animation];
  end;
//______________________________________________________________________________
begin
  for I:=0 to Map.MofBot-1 do
  if BotP2[I].Live>1 then

  if Map.Bot[I].T in [5] then
   bot1work
  else
   bot2work;
end;

procedure Draw;
var
  Flag,
  I : integer;
begin

  for I:=0 to Map.MofBot-1 do
    begin
      if BotP2[I].Left then Flag:=FX_DEFAULT or FX_FLIPX
      else Flag:=1;
      if Map.Bot[I].T>0 then
      Omega.ASprite_Draw(TBot[Map.Bot[I].T,
                         BotP2[I].Animation], Map.Bot[I].X-CameraX, Map.Bot[I].Y-CameraY,
                         BotT[Map.Bot[I].T].W, BotT[Map.Bot[I].T].H,
                         round(BotP2[I].AnimationN), 255, 0, Flag);

    end;
end;


end.
