program MapEditor;

uses
  Windows,
  OpenGL,
  eXgine,
  Game    in 'Game.pas',
  Player  in 'Player.pas',
  Guns    in 'Guns.pas',
  Enemies in 'Enemies.pas',
  DePack  in 'DePack.pas';

{
   to do:
  +  1)   (  
           ,     )
  +  2)    

}

procedure Init;
begin
  wnd.Mode(true, 1024, 768, 32, 85);
  tex.Filter(FT_ANISOTROPY);

  DePackRes;
  GameInit;

  inp.MCapture(false);
  ShowCursor(false);
end;

procedure Free;
begin
  FreeBullets;
  EnemiesFree;

  ClearTmp;
end;

procedure Update;
begin
  GameInput;
  GameUpdate;
end;

procedure Render;
begin
  ogl.Clear(true, true);
  ogl.Set3D(90,0.1, 1024);
 // glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

  GameRender;

  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  glColor3f(1, 0, 0);
  ogl.TextOut(0, 5, 5, PChar('FPS: ' + IntToStr(ogl.FPS)));
  ogl.TextOut(0, 15, 15, PChar(IntToStr(PRec.param)));
  ogl.TextOut(0, 15, 25, PChar(IntToStr(BCount)));
  ogl.TextOut(0, 15, 35, PChar(IntToStr(ECount)));
  ogl.TextOut(0, 15, 45, PChar(IntToStr(PRec.hp)));
end;

begin
  wnd.Create(PChar('IGDC #47'), False);
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);
  eX.SetProc(PROC_INIT, @Init);
  eX.SetProc(PROC_FREE, @Free);
//    
  eX.MainLoop(50);
end.

