program Packer;

{$APPTYPE CONSOLE}

uses
  SysUtils, zlib, Windows, classes;

  var
    source,dest: TFileStream;//-, -
    CompresSstream:TCompressionStream;    //  - 
    decompressStream:TDecompressionStream;
    bytesread:integer;
    mainbuffer:array[0..1023] of char; // 

    f, r: string;
    i   : integer;

procedure Compress(FileName, _r : string);
begin
    source:=TFileStream.Create(FileName+_r,fmOpenRead);   //   - 
    dest:=TFileStream.Create(FileName+'.pgf',fmCreate); //   - 
    CompresSstream:=TCompressionStream.Create(clMax,dest);//   -  c                   //            
    try                //   
      repeat
        bytesread:=source.Read(mainbuffer,1024);    //     
        CompresSstream.Write(mainbuffer,bytesread);     //        - 
      until bytesread<1024;   //           
  except    //       - !!!
    CompresSstream.free;
    source.Free;
    dest.Free;
    exit;
  end;   //   

  CompresSstream.free;
  source.Free;
  dest.Free;
end;

procedure DeCompress(FileName, _r : string);
begin
  source:=TFileStream.Create(FileName+'.pgf',fmOpenRead);
  dest:=TFileStream.Create(FileName+_r,fmCreate);
  decompressStream:=TDecompressionStream.Create(source); //
  try
    repeat
      bytesread:=decompressStream.Read(mainbuffer,1024);
      dest.Write(mainbuffer,bytesread);
    until bytesread<1024;
  except
    decompressStream.Free;
    source.Free;
    dest.Free;
    exit;
  end;
  decompressStream.Free;
  source.Free;
  dest.Free;
end;

begin
  try
    i:=1;
     while i<=18 do
      begin
        case i of
          1: begin
               f:='Data\GFX\Bullet';
               r:='.tga';
             end;
          2: begin
               f:='Data\GFX\cross';
               r:='.tga';
             end;
          3: begin
               f:='Data\SPR\EFly';
               r:='.tga';
             end;
          4: begin
               f:='Data\SPR\ERocket';
               r:='.tga';
             end;
          5: begin
               f:='Data\SPR\ERunner';
               r:='.tga';
             end;
          6: begin
               f:='Data\SPR\ESphere';
               r:='.tga';
             end;
          7: begin
               f:='Data\SPR\GGArm';
               r:='.tga';
             end;
          8: begin
               f:='Data\SPR\GGBody';
               r:='.tga';
             end;
          9: begin
               f:='Data\SPR\GGHead';
               r:='.tga';
             end;
          10:begin
               f:='Data\SPR\GGJump';
               r:='.tga';
             end;
          11:begin
               f:='Data\SPR\GGLegs';
               r:='.tga';
             end;
          12:begin
               f:='Data\SPR\GGPistol';
               r:='.tga';
             end;
          13:begin
               f:='Data\SPR\GGRun';
               r:='.tga';
             end;
          14:begin
               f:='Data\SPR\GGSit';
               r:='.tga';
             end;
          15: begin
               f:='Data\GFX\Energy';
               r:='.tga';
             end;
          16: begin
               f:='Data\GFX\Shield';
               r:='.tga';
             end;
          17: begin
               f:='Data\GFX\StartScreen1';
               r:='.tga';
             end;
          18: begin
               f:='Data\Tex\Back\Ruins';
               r:='.tga';
             end;
        end;
        Compress(f, r);
        WriteLn('File ',f,r,' succesfully compressed.');
        sleep(1000);
        inc(i);
      end;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
