#ifndef _I_MANAGERS_FACTORY_H_INCLUDED_
#define _I_MANAGERS_FACTORY_H_INCLUDED_

namespace DPE_Scenes
{
//-----------------------------------------------------------------------
//IManagersFactory//
//-----------------------------------------------------------------------

// {94A082A0-2F9E-4873-87D2-98441895049B}
static const GUID IID_IManagersFactory = 
{ 0x94a082a0, 0x2f9e, 0x4873, { 0x87, 0xd2, 0x98, 0x44, 0x18, 0x95, 0x4, 0x9b } };

interface __declspec(uuid("{94A082A0-2F9E-4873-87D2-98441895049B}")) IManagersFactory: public ICommonPlugin
{
	virtual HRESULT CALLBACK GetResourceManager(OUT IResourceManager *&pResourceManager) = 0;
	virtual HRESULT CALLBACK GetManager2D(OUT _2D::IManager2D *&pManager2D) = 0;
	virtual HRESULT CALLBACK GetManager3D(OUT _3D::IManager3D *&pManager3D) = 0;
	virtual HRESULT CALLBACK GetGUIManager(OUT GUI::IDPEGUIManager *&pGUIManager) = 0;
};
}

#endif// _I_MANAGERS_FACTORY_H_INCLUDED_