/*-----------------------------------------------------------------------
This source file is a part of DPEngine.

Created:		04.04.2008
LastModified:	04.04.2008

Revision history:
	* Created by Gas
	* Revised by Mike

Disctription:
-----------------------------------------------------------------------*/
#ifndef SCALAR_H
#define SCALAR_H

enum {LEFT,  RIGHT,  BEYOND,  BEHIND, BETWEEN, ORIGIN, DESTINATION, INTERSECTS};
//    , , , , ,   , ,       
enum ORIENTATION {CW, CCW};

#define PI 3.14159265358979323846
#define DEGTORAD(deg) ((float)(deg*(PI/180.f)))
#define RADTODEG(rad) ((float)(rad*(180.f/PI)))

#endif