/*-----------------------------------------------------------------------
This source file is a part of DPEngine.

Created:		16.06.2008
LastModified:	16.06.2008

Revision history:
	* Created by Mike
	* Revised by

Disctription:
-----------------------------------------------------------------------*/
#ifndef _PLANE_H_INCLUDED_
#define _PLANE_H_INCLUDED_

#include "Vector.h"

#include "DEFINE_FOR_BORLANDC"

namespace DPE_Scenes
{

struct TPlane
{
	Vector Normal;
	float Distance;

	TPlane();
	TPlane(const Vector &vNormal, const Vector &vPoint);
	TPlane(const Vector &vA, const Vector &vB, const Vector &vC);
	bool LineIntersected(const Vector &vA, const Vector &vB);
	Vector IntersectionPoint(const Vector &vA, const Vector &vB);
	float DistanceToPoint(const Vector &vPoint);
};

}

#include "UNDEF_FOR_BORLANDC"

#endif