#pragma once

#include <DPE_Application_Include.h>
#include "Game.h"
#include <StringUtils.h>
#include <vector>
#include <string>
using namespace std;


struct TBullet
{
	ISprite *sprite;
	IBody	*body;
	bool	isbullet;
	TBullet::TBullet(ISprite *s,IBody *b, bool blt)
	{
		body = b;
		sprite = s;
		isbullet = blt;
	}
};

struct TCb
{
	unsigned long id;
	bool bul;
	TCb::TCb(unsigned long a, bool b)
	{
		id = a;
		bul = b;
	}
};

class Bullets {

private:
	
	static int			efidx;
	IEngineCore			*pEngineCore;
	IManagersFactory 	*pSceneManFact;
	IResourceManager	*pMainResManager;
	IManager2D			*pMan2D;
	IContactListener	*pListner;

	int					_counter;
	vector<TBullet>		_bullets;

	vector<TCb>			_idxss;

	void				_killbullet(int idx); 

public:
	
	void MakeShot(Point2D_Int pos, bool bullet);
	void Update();
	bool CollideWith(unsigned long idx, bool bullet);

	Bullets(IEngineCore *eng);
	~Bullets();

};