#ifndef _BOSS_H_
#define _BOSS_H_

#include <DPE_Application_Include.h>
#include <StringUtils.h>

class CBoss
{
public:

	static int _counter;
	CBoss( const char *name, IEngineCore *core);
	~CBoss();
	void setPosition(const Point2D_Int &pos);
	void update();

protected:
	// system
	_2D::ISprite			*pBossSprite;
	IEngineCore				*mCore;
	IManager2D				*mMan2d;
	IResourceManager		*mResMan;
	Point2D_Int				position;
	float	angle;
	bool back_ang;
};

#endif	