//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	DecimalSeparator = '.';
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
_appcore = new AppCore(Panel1->Handle,true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
delete _appcore;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
Form3->Button5->Click();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Panel2Click(TObject *Sender)
{
 _appcore->map()->mouseobj.density = StrToFloat(Form3->Edit1->Text);
 _appcore->map()->mouseobj.isstatic = Form3->CheckBox1->Checked;
 _appcore->map()->mouseobj.ispassable = Form3->CheckBox2->Checked;
 _appcore->map()->AddToMapCurObj();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Panel2MouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y)
{
  if(!_appcore->map()->mouseobj.ispoly)
  {
	  int _cx, _cy;
	  switch(_appcore->map()->mouseobj.ground)
	  {
		  case 0:
		  _cx = _appcore->map()->CameraX/2;
		  _cy = _appcore->map()->CameraY/2;
		  break;
		  case 1:
		  _cx = _appcore->map()->CameraX;
		  _cy = _appcore->map()->CameraY;
		  break;
		  case 2:
		  _cx = _appcore->map()->CameraX*2;
		  _cy = _appcore->map()->CameraY*2;
		  break;
	  }
	  _appcore->map()->mouseobj.XCoord[0] = X - _cx;
	  _appcore->map()->mouseobj.YCoord[0] = Y - _cy;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ApplicationEvents1Message(tagMSG &Msg, bool &Handled)
{
		if(Msg.message== WM_KEYDOWN)
		{
		if ((unsigned int)Msg.wParam=='A') _appcore->map()->CameraX+=3;
		if ((unsigned int)Msg.wParam=='D') _appcore->map()->CameraX-=3;
		if ((unsigned int)Msg.wParam=='W') _appcore->map()->CameraY+=3;
		if ((unsigned int)Msg.wParam=='S') _appcore->map()->CameraY-=3;

		if ((unsigned int)Msg.wParam==37) _appcore->map()->mouseobj.w-=1;
		if ((unsigned int)Msg.wParam==39) _appcore->map()->mouseobj.w+=1;
		if ((unsigned int)Msg.wParam==38) _appcore->map()->mouseobj.h-=1;
		if ((unsigned int)Msg.wParam==40) _appcore->map()->mouseobj.h+=1;
		}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Panel2ContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled)
{
  _appcore->map()->DeleteMapObj(MousePos.x,MousePos.y);
}
//---------------------------------------------------------------------------

