unit DEnemy;

interface

uses
  DMath,
  DGame,
  DMap;

type
CEnemy = class of TEnemy;

TEntryRespawn = class(TEntry)
private
  FType: CEnemy;
  FCount: Integer;
  FInterval: Single;
  FOnce: Boolean;
public
  constructor Create(Map: TMap;
                     Name: String; 
                     Rect: TRect; 
                     _Type: CEnemy; 
                     Count: Integer; 
                     Interval: Single;
                     Once: Boolean);
  procedure DoActivate; override;
  procedure Update; override;
end;

implementation

//{{{ TEntryRespawn
constructor TEntryRespawn.Create;
begin
  inherited Create(Map, Name, Rect);
  FType := _Type;
  FCount := Count;
  FInterval := Interval;
  FOnce := Once;
end;

procedure TEntryRespawn.DoActivate;
begin
end;

procedure TEntryRespawn.Update;
begin
end;
//}}}

end.
