﻿package elm.core {
	import flash.display.*;
	import flash.events.*;
	
	public class Preloader extends MovieClip {		
		public function Preloader() {
			//super();
			stop();
			loaderInfo.addEventListener(ProgressEvent.PROGRESS, onProgressEvent);
			loaderInfo.addEventListener(Event.COMPLETE, onCompleteEvent);
		}
		private function onProgressEvent(e:ProgressEvent):void {
			var loaded:uint = e.bytesLoaded;
			var total:uint = e.bytesTotal;
			onProgress(Math.round(loaded / total * 100));
		}
		private function onCompleteEvent(e:Event):void {
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			//gotoAndStop(GetEntryFrame());
			play();
		}
		private function onEnterFrame(e:Event):void {
			if (currentFrame >= GetEntryFrame()) {
				removeEventListener(Event.ENTER_FRAME, onEnterFrame);
				stop();
				main();
			}
		}
		private final function main():void {
			Log.Message("DocumentClass: "+GetDocumentClass());
			var mainClass:Class = loaderInfo.applicationDomain.getDefinition(GetDocumentClass()) as Class;
			addChild(new mainClass());
		}
		public function onProgress(persent:Number):void {
			Log.Message(persent+"%");
		}
		public function GetEntryFrame():uint {
			return 3;
		}
		public function GetDocumentClass():String {
			return "Main";
		}
	}
}