package game {
	import flash.display.DisplayObject;
	import flash.events.EventDispatcher;
	import game.room.Room;

	public class Entity extends EventDispatcher {
		private static var idCnt:int = -1;
		
		public var id:int;
		public var attr:Object;
		public var room:Room = null;
		
		public function Entity(attrIn:Object = null) {
			id = ++idCnt;
			attr = attrIn;
		}
		public function free():void {
			room = null;
			attr = null;
		}
		
		public function kill():void {
			dispatchEvent(new EntityEvent(this, EntityEvent.KILLED));
		}
		
		public function getVisualObject():DisplayObject {
			return null;
		}
		
		public function setRoom(roomIn):void {
			room = roomIn;
		}
	}
}