﻿package game.actor.enemies {
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.b2Body;
	import game.actor.*;
	import game.actor.player.PlayerActor;

	public class Enemy extends WalkingActor implements DamagedActor {
		protected var player:PlayerActor = null;
		
		public function Enemy(attrIn:Object) {
			super(attrIn);
		}
		public override function free():void {
			player = null;
			super.free();
		}
		
		public override function update(delta:Number):void {
			if (health <= 0) die();
			
			super.update(delta);
		}
		
		public function damage(param:Object):void {
			health -= param.damage;
		}
		
		public override function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			super.onContactUpdate(shape, reverse, contactPoint);
		}
	}
}