package physic {
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.Contacts.b2ContactResult;

	public interface ContactRecipient {
	
		function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void;
		function onContactRemove(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void;
		function onContactResult(shape:b2Shape, reverse:int, contactResult:b2ContactResult):void;
	}
}