#include "Player.h"

#include "PLD3DEngine\includes.h"

CPlayer::CPlayer(void)
{
	life = 10;
	bDie = FALSE;
	pos = CVector(-300,100,0);
	vec = CVector(0,0,0);
	State = STATE_NORM;
	jump_index = -1;
	//n_bullet = 0;
	bFire=TRUE;
	between_fire = BETWEEN_FIRE;
	for(int i=0;i<NUM_BULLETS;i++) {
		bullet[i].b_bullet=FALSE;
		bullet[i].vec=CVector(3,0,0);
		bullet[i].pos=CVector(0,0,0);
	}
	

}

CPlayer::~CPlayer(void)
{
}

void CPlayer::Fire(CVector player_pos)
{

	if (bFire) {
		
		for(int b=0;b<NUM_BULLETS;b++){
			if (!bullet[b].b_bullet){
				//n_bullet++;
				bullet[b].b_bullet=TRUE;//!bullet[b].b_bullet;
				bullet[b].fire_len = FIRE_LEN;
				bullet[b].pos=player_pos+CVector(30,40,-40);
				
				between_fire = BETWEEN_FIRE;
				b=NUM_BULLETS;
				//MessageBox(NULL, "fire!", "Debug!", MB_OK);
			}
		}
	}
}


void CPlayer::FireFly(float _GS)
{
	// PAUSE BETWEEN FIRE //
	if (between_fire>0) { between_fire--; bFire=FALSE; }
	else bFire = TRUE;


	for(int b=0;b<NUM_BULLETS;b++){
	//int b=0;
		if (bullet[b].b_bullet){
			bullet[b].pos+=bullet[b].vec*0.1f*_GS;
			bullet[b].fire_len--;
			if (bullet[b].fire_len<0) bullet[b].b_bullet=false;
		}
	}

}
/*void CPlayer::PlayerState(int _state)
{
	if (_state>0) State = _state;

	if (State==STATE_UP){
		jump_index = 100;
	}


}*/

/*void CPlayer::Jump(float _GS)
{
	jump_index -= 0.1f * _GS;
	
	if (jump_index > 50.0f) Player.vec = CVector(1,1,0);
	if (jump_index < 50.0f) Player.vec = CVector(1,-1,0);
	
}*/


void CPlayer::Go(float _GS){
/*	pos+=vec*(0.1f*GS);


	if (State==STATE_NORM) vec=CVector(0,0,0);
	//if (Player.jump_index>-1) Player.jump_index-=1;
	if (State==STATE_UP) {
		if (jump_index>-1) jump_index-=1;
		//		Player.jump_index-=1;//1.0f*GS;
		if (jump_index<500) vec=CVector(1,-1,0);
		if (jump_index<0) State=STATE_NORM;
	}


	int in;

	// PLAYER DISPLACE //
	int i_x[4],i_y[4];
	float f_x[4],f_y[4];
	int block_around_pl_x[4],block_around_pl_y[4];
	
	f_x[0] = (pos.x-LEVEL_X_OFFSET-20)/50.0f;
	f_y[0] = (pos.y-20)/50.0f;
	f_x[1] = (pos.x-LEVEL_X_OFFSET+20)/50.0f;
	f_y[1] = (pos.y-20)/50.0f;
	f_x[2] = (pos.x-LEVEL_X_OFFSET-20)/50.0f;
	f_y[2] = (pos.y+20)/50.0f;
	f_x[3] = (pos.x-LEVEL_X_OFFSET+20)/50.0f;
	f_y[3] = (pos.y+20)/50.0f;

	// ROUND X,Y //
	for (int i=0;i<4;i++){
		i_x[i] = int(f_x[i]);	i_y[i] = int(f_y[i]);
		if (fabs(f_x[i]-i_x[i])>0.5f) i_x[i]++;	if (fabs(f_y[i]-i_y[i])>0.5f) i_y[i]++;
		block_around_pl_x[i] = i_x[i];	block_around_pl_y[i] = i_y[i];
	}
		
	float tst_fl,tst_fl2;

	float intp;
	float fltp;
	float flx;
		


		//float float_x = (float)Player.pos.x/50.0f;
	for (int i=0;i<4;i++){
		if (Level[block_around_pl_x[i]][block_around_pl_y[i]] > 0) {
			// JUMP //
			if (Player.State==STATE_UP){
				// STOP //	
				Player.State=STATE_NORM;
				Player.jump_index=-1;
			
				Player.vec=-Player.vec*5.0f;
				Player.pos+=Player.vec;
				//MessageBox(NULL, "Jump Move Stop!", "Debug", MB_OK);
			}

			// PLAYER MOVE LEFT-RIGHT //
			
//			}
		

		}
	}


		

	// PLAYER GRAVITY //
	int gravity_index = 50;
	if (Player.State!=STATE_UP)
	for (int i=0;i<gravity_index ;i++){
		Player.pos.y-=0.005f*GS;
		//block_around_pl_x = (Player.pos.x-LEVEL_X_OFFSET)/50.0f;
		//block_around_pl_y = Player.pos.y/50.0f;
		
		// ROUND X,Y //
		for (int i=0;i<4;i++){
			i_x[i] = int(f_x[i]);	i_y[i] = int(f_y[i]);
			if (fabs(f_x[i]-i_x[i])>0.5f) i_x[i]++;	if (fabs(f_y[i]-i_y[i])>0.5f) i_y[i]++;
			block_around_pl_x[i] = i_x[i];	block_around_pl_y[i] = i_y[i];
		
			if ((Level[block_around_pl_x[i]][block_around_pl_y[i]]>0)||(Player.pos.y<0)) {
				Player.pos.y+=0.01f*GS; 
				i=gravity_index; 
				// STOP //	
				Player.jump_index=-1;
			}
		}
	}*/
}