#ifndef ONCE_GLOBALS
#define ONCE_GLOBALS

#include <math.h>

#include ".\hge\include\hge.h"

extern HGE *hge;
extern bool SHOW_INFO;

const int SCREEN_WIDTH	= 800;
const int SCREEN_HEIGHT	= 600;

const float PI_2 = M_PI * 2.0f;
const float M_PI_6 = M_PI / 6.0f;
const float RADIANS = M_PI / 180.0f;
const float DEGREES = 180.0f / M_PI;

const float DIAG = 1.0f / sqrt(2.0f);

typedef int Vector2i[2];
typedef int Array4i[4];

typedef float Vector2f[2];
float VectorAngle(Vector2f& v);
float VectorLength(Vector2f& v);
void VectorNormalize(Vector2f& v);
void VectorDivide(Vector2f& v, float n);

int round (const float t);
int random (const int t);
float random (const float t);

#endif