program MapEditor;

uses
  Windows,
  OpenGL,
  eXgine,
  Editor in 'Editor.pas';

procedure Init;
begin
  wnd.Mode(true, 800, 600, 32, 85);
  EditorInit;

  inp.MCapture(false);
end;

procedure Free;
begin
  EditorFree;
end;

procedure Update;
begin
  EditorUpdate;
end;

procedure Render;
var
  i : Integer;
begin
  EditorRender;

  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  glColor3f(1, 0, 0);
  ogl.TextOut(0, 5, 5, PChar('FPS: ' + IntToStr(ogl.FPS)));
end;

begin
  wnd.Create(PChar('MapEditor'), False);
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);
  eX.SetProc(PROC_INIT, @Init);
  eX.SetProc(PROC_FREE, @Free);
//    
  eX.MainLoop(50);
end.

