program Packer;

{$APPTYPE CONSOLE}

uses
  SysUtils, zlib, Windows, classes;

  var
    source,dest: TFileStream;//-, -
    CompresSstream:TCompressionStream;    //  - 
    decompressStream:TDecompressionStream;
    bytesread:integer;
    mainbuffer:array[0..1023] of char; // 

    f, r: string;

procedure Compress(FileName, _r : string);
begin
    source:=TFileStream.Create(FileName+_r,fmOpenRead);   //   - 
    dest:=TFileStream.Create(FileName+'.pgf',fmCreate); //   - 
    CompresSstream:=TCompressionStream.Create(clMax,dest);//   -  c                   //            
    try                //   
      repeat
        bytesread:=source.Read(mainbuffer,1024);    //     
        CompresSstream.Write(mainbuffer,bytesread);     //        - 
      until bytesread<1024;   //           
  except    //       - !!!
    CompresSstream.free;
    source.Free;
    dest.Free;
    exit;
  end;   //   

  CompresSstream.free;
  source.Free;
  dest.Free;
end;

procedure DeCompress(FileName, _r : string);
begin
  source:=TFileStream.Create(FileName+'.pgf',fmOpenRead);
  dest:=TFileStream.Create(FileName+_r,fmCreate);
  decompressStream:=TDecompressionStream.Create(source); //
  try
    repeat
      bytesread:=decompressStream.Read(mainbuffer,1024);
      dest.Write(mainbuffer,bytesread);
    until bytesread<1024;
  except
    decompressStream.Free;
    source.Free;
    dest.Free;
    exit;
  end;
  decompressStream.Free;
  source.Free;
  dest.Free;
end;

begin
  try
    ReadLn(f);
    ReadLn(r);
    Compress(f, r);
    WriteLn('File ',f,r,' succesfully compressed.');
    sleep(3000);
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
