unit DePack;

interface

uses Windows, Zlib, classes, eXgine;

procedure DePackRes;
procedure ClearTmp;
procedure DeCompress(FileName, _r : string);

var
    source,dest: TFileStream;//-, -
    CompresSstream:TCompressionStream;    //  - 
    decompressStream:TDecompressionStream;
    bytesread:integer;
    mainbuffer:array[0..1023] of char; // 

    f, r: string;
    i   : integer;

const
   fmOpenRead       = $0000;

implementation

procedure DeCompress(FileName, _r : string);
begin
  source:=TFileStream.Create(FileName+'.pgf',fmOpenRead);
  dest:=TFileStream.Create(FileName+_r,fmCreate);
  decompressStream:=TDecompressionStream.Create(source); //
  try
    repeat
      bytesread:=decompressStream.Read(mainbuffer,1024);
      dest.Write(mainbuffer,bytesread);
    until bytesread<1024;
  except
    decompressStream.Free;
    source.Free;
    dest.Free;
    exit;
  end;
  decompressStream.Free;
  source.Free;
  dest.Free;
end;

procedure DePackRes;
begin
  i:=1;
  try
   while i<=18 do
      begin
        case i of
          1: begin
               f:='Data\GFX\Bullet';
               r:='.tga';
             end;
          2: begin
               f:='Data\GFX\cross';
               r:='.tga';
             end;
          3: begin
               f:='Data\SPR\EFly';
               r:='.tga';
             end;
          4: begin
               f:='Data\SPR\ERocket';
               r:='.tga';
             end;
          5: begin
               f:='Data\SPR\ERunner';
               r:='.tga';
             end;
          6: begin
               f:='Data\SPR\ESphere';
               r:='.tga';
             end;
          7: begin
               f:='Data\SPR\GGArm';
               r:='.tga';
             end;
          8: begin
               f:='Data\SPR\GGBody';
               r:='.tga';
             end;
          9: begin
               f:='Data\SPR\GGHead';
               r:='.tga';
             end;
          10:begin
               f:='Data\SPR\GGJump';
               r:='.tga';
             end;
          11:begin
               f:='Data\SPR\GGLegs';
               r:='.tga';
             end;
          12:begin
               f:='Data\SPR\GGPistol';
               r:='.tga';
             end;
          13:begin
               f:='Data\SPR\GGRun';
               r:='.tga';
             end;
          14:begin
               f:='Data\SPR\GGSit';
               r:='.tga';
             end;
          15: begin
               f:='Data\GFX\Energy';
               r:='.tga';
             end;
          16: begin
               f:='Data\GFX\Shield';
               r:='.tga';
             end;
          17: begin
               f:='Data\GFX\StartScreen1';
               r:='.tga';
             end;
          18: begin
               f:='Data\Tex\Back\Ruins';
               r:='.tga';
             end;
        end;
        DeCompress(f, r);
        LogOut('File '+f+r+' succesfully UnPacked.');
        inc(i);
      end;
  except
    LogOut('Can not UnPack game resourses. App will be killed');
  end;

 end;


procedure ClearTmp;
begin
 { CreateProcess(nil, PChar('Data\GFX\tmpcleaner.bat'),
                nil,nil, false, Create_Default_error_mode, nil, nil, 0, 0);
  }

  DeleteFile('Data\GFX\Bullet.tga');
  DeleteFile('Data\GFX\Cross.tga');
  DeleteFile('Data\GFX\Energy.tga');
  DeleteFile('Data\GFX\Shield.tga');
  DeleteFile('Data\GFX\StartScreen1.tga');


  DeleteFile('Data\SPR\EFly.tga');
  DeleteFile('Data\SPR\ERocket.tga');
  DeleteFile('Data\SPR\ERunner.tga');
  DeleteFile('Data\SPR\ESphere.tga');
  DeleteFile('Data\SPR\GGArm.tga');
  DeleteFile('Data\SPR\GGBodu.tga');
  DeleteFile('Data\SPR\GGHead.tga');
  DeleteFile('Data\SPR\GGJump.tga');
  DeleteFile('Data\SPR\GGLegs.tga');
  DeleteFile('Data\SPR\GGPistol.tga');
  DeleteFile('Data\SPR\GGRun.tga');
  DeleteFile('Data\SPR\GGSit.tga');


  DeleteFile('Data\Tex\Back\Ruins.tga');


  LogOut('Temp files succesfully deleted');

  LogOut('----====::::  For questions: the-Exile@list.ru  ::::====----');

end;



end.
